@echo off
echo.
echo Poor Man's Versioning: Backup
echo -----------------------------
goto begin

:usage
echo.
echo Usage: %~n0 srcfolder [pmvFolder [pmvVersions]]
echo.
echo Makes a copy of latest revisions (based on archive attribute)
echo from srcfolder to a sub-directory in pmvFolder.  Both parameters 
echo must be valid folder names.  (pmvFolder is optional if it is
echo already set as an environment variable.)
echo pmvVersions is an optional parameter indicating the number of
echo prior versions to keep (default=10).  It may also be set as
echo an environment variable.
echo.
call pmvReleaseInfo.cmd
set /p pmvSrc="Press Enter to quit."
goto end

:begin
setlocal ENABLEDELAYEDEXPANSION
if "%~1"==""         (echo Error: Insufficient parameters: %*&goto usage)
if not "%~4"==""     (echo Error: Too many parameters: %*&goto usage)
if not exist "%~1\*" (echo Error: "%~1" is not a folder.&goto usage)

:: process command-line options
set "pmvSrc=%~f1"
if %pmvSrc:~-1%==\ set "pmvSrc=%pmvSrc:~0,-1%"
set "pmvTail=%pmvSrc::=%"
set "pmvTail=%pmvTail:\\=%"
if not "%~2"=="" set "pmvFolder=%~f2"
if not defined pmvFolder (echo Error: pmvFolder not specified.&goto usage)
if not %pmvFolder:~-1%==\ set "pmvFolder=%pmvFolder%\"
if not exist "%pmvFolder%*" (echo Error: "%pmvFolder%" is not a folder.&goto usage)
if not "%3"=="" set pmvVersions=%3
if not defined pmvVersions set pmvVersions=10
if %pmvVersions% LSS 1     set pmvVersions=10
if %pmvVersions% GEQ 100   set pmvVersions=99
if %pmvVersions% LSS 10    set pmvVersions=0%pmvVersions%

:: shift old folders
if exist "%pmvFolder%%pmvVersions%" (
  echo Removing folder "%pmvFolder%%pmvVersions%"...
  rd /s /q "%pmvFolder%%pmvVersions%"
  echo ...Done.
)
echo Shifting folders "%pmvFolder%##"...
for /l %%n in (%pmvVersions%,-1,2) do (
  set /a i=%%n-1
  set /a j=%%n
  if %%n LEQ 10 set i=0!i!
  if %%n LSS 10 set j=0!j!
  if exist "%pmvFolder%!i!" move /y "%pmvFolder%!i!" "%pmvFolder%!j!" > nul
)
set i=
set j=
echo ...Done.

:: build exclusion list
echo Building exclusion list...
if exist %~n0.exclude copy /y %~n0.exclude %TMP% > nul
echo %pmvFolder% >> %TMP%\%~n0.exclude
echo %TMP%  >> %TMP%\%~n0.exclude
echo ...Done.

set pmvFolder=%pmvFolder%01\%pmvTail%
echo Creating folder "%pmvFolder%"...
md "%pmvFolder%"
echo ...Done.
set pmvTail=

:: copy modified files
echo Copying changed files...
echo on
xcopy "%pmvSrc%\*.*" "%pmvFolder%" /m /c /h /k /s /x /y /exclude:%TMP%\%~n0.exclude
@echo off
echo ...Done.

:end
set pmvSrc=
set pmvFolder=
set pmvVersions=
