@echo off
echo.
echo Poor Man's Versioning: Restore
echo ------------------------------
goto begin

:usage
echo.
echo Usage: %~n0 file [pmvFolder]
echo.
echo Lists earlier versions of file stored in pmvFolder by pmvBackup
echo and allows you to select one to replace the current file with.
echo Backs up current file to file.BAK before replacing.
echo.
echo pmvFolder is an optional parameter, read from an environment
echo variable of the same name if not found.
echo.
call pmvReleaseInfo.cmd
goto end

:begin
setlocal ENABLEDELAYEDEXPANSION
if "%~1"==""         (echo Error: Insufficient parameters: %*&goto usage)
if not "%~3"==""     (echo Error: Too many parameters: %*&goto usage)
if not exist "%~1"   (echo Error: "%~1" not found.&goto usage)
if exist "%~1\*"     (echo Error: "%~1" is not a file.&goto usage)

:: process command-line options

:: need quotes in next to wrap possible "&" in path
set "pmvPath=%~f1"
set "pmvFile=%~nx1"
set "pmvTail=%pmvPath::=%"
set "pmvTail=%pmvTail:\\=%"
if not "%~2"=="" set "pmvFolder=%~f2"
if not defined pmvFolder (echo Error: pmvFolder not specified.&goto usage)
if not %pmvFolder:~-1%==\ set "pmvFolder=%pmvFolder%\"
if not exist "%pmvFolder%*" (echo Error: "%pmvFolder%" is not a folder.&goto usage)

echo Current version of "%pmvFile%":
for /f "tokens=*" %%a in ('dir "%pmvPath%"') do echo.       "%%a" | find /i "%pmvFile%"
echo.
echo Select version to restore:
set found=
for /l %%n in (1,1,99) do (
  set /a j=%%n
  if %%n LSS 10 set j=0!j!
  if exist "%pmvFolder%!j!\%pmvTail%" (
    for /f "tokens=*" %%a in ('dir "%pmvFolder%!j!\%pmvTail%"') do echo.  [!j!] "%%a" | find /i "%pmvFile%"
    set found=1
  )
)
if not defined found (echo Sorry, no earlier versions found. Use pmvBackup to store versions.& goto end)
set /p pmvChoice="Version to restore [## or Enter to cancel]:"
if "%pmvChoice%"=="" echo Restore cancelled. &goto end
if %pmvChoice% LSS 10 (if %pmvChoice:~0,1% NEQ 0 set pmvChoice=0%pmvChoice%)
if not exist "%pmvFolder%%pmvChoice%\%pmvTail%" echo Input "%pmvChoice%" not recognized.  Restore cancelled. &goto end

:: backup file
echo.
echo Backing up current version to "%pmvFile%.BAK"...
copy /y "%pmvPath%" "%pmvPath%.BAK"
echo ...Done.

:: restore file
echo.
echo Restoring version [%pmvChoice%]...
copy /-y "%pmvFolder%%pmvChoice%\%pmvTail%" "%pmvPath%"
echo ...Done.

:end
set pmvPath=
set pmvFile=
set pmvFolder=
set pmvTail=
set pmvChoice=
